
/********************************************************************************
 *										*
 *				 M A C E K					*
 *		("Matroids Also Computed Efficiently" Kit)			*
 *										*
 * A set of tools and routines for computations with representable matroids.	*
 * Copyright (C) 2001,2002  Petr Hlineny.					*
 *										*
 *   This program is free software; you can redistribute it and/or modify	*
 *   it under the terms of the GNU General Public License as published by	*
 *   the Free Software Foundation; either version 2 of the License, or		*
 *   (at your option) any later version.					*
 *   You should have received a copy of the GNU General Public License		*
 *   along with this program; if not, write to the Free Software		*
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.	*
 * 										*
 * See the top-level "ABOUT" and "doc/ *" files for more information.		*
 *										*
 ********************************************************************************/














/**
 * 
 * various general variables and functions for the package.....
 * 
 * 
**/



#include "macek.h"









/******************	Miscelanelous	*******************/
/**********************************************************/


/**
 * 
 * some variables................
 * 
**/


int	perror_occured = 0;
int	uerror_occured = 0;
int	crash_all_errors = 0;

int	junk = 0;

int	printlev = DEBUGLEV-3;

void	*mmmm;	/* used in macros... */
char	*ssss,  debugoutbuf[10000];


FILE	*errorout,
	*debugout,
	*printout;

char	*printoutpref = "    ~\t";


#ifdef snprintf		/* replacement of snprintf() on systems without it */
char	snprintf_buf[10000];
#endif










/******************	File utilities	*******************/
/**********************************************************/



/**
 * 
 * 
 * trying to open fn in mode mod, using path and optional extension.......
 * 	(extension is forced first when writing and no ext...),
 * 	about overwrite-protection (not for /tmp),
 * 	creating missing directories on write...
 * 
**/

char	*fopen_dirused;		/* records the directory found in the path during open */

FILE*	fopen_path(char *fn, char *mod, char **path, char *dir, char *ext) {
	char	*dfn, *buf, *x;
	FILE	*fp = NULL;
	int	i,j,l,w, bl1,bl2;
	
	if (fn==NULL || path==NULL) {
		PROGERROR("No filename or path given for reading!");  return NULL;
	}
				/* removing leading and trailing whitespaces */
	while (*fn==' ' || *fn=='\t' || *fn=='\n')  fn++;
	dfn = MSTRDUP(fn);
	for (i=strlen(dfn)-1; i>=0 && (dfn[i]==' ' || dfn[i]=='\t' || dfn[i]=='\n'); i--) ;
	dfn[i+1] = 0;
	bl1 = strlen(dfn)+(ext?strlen(ext):0)+(dir?strlen(dir):0)+32;
	bl2 = strlen(path[0])+500;
	buf = MMALLOC((bl1+bl2)*sizeof(buf[0]));
	
	w = (mod[0]=='w');	/* the extension is preferred when writing and no extension exists in fn */
	for (x=dfn+strlen(dfn)-1; x>dfn && x[0]!='/' && x[0]!='.'; x--) ;
	if (w && x[0]=='.')  ext = NULL;
	
	i = -1;			/* looking for the file to open: */
	if (dfn[0]=='/' ||\
			(dfn[0]=='.'&&dfn[1]=='/') || (dfn[0]=='.'&&dfn[1]=='.'&&dfn[2]=='/'))
		for (j=0; j<2 && !fp; j++) {	/* (openning absolute file name) */
			strcpy(buf,dfn);
			if (j==1 && !ext)  continue;
			if (j==(!w) && ext) { strcat(buf,ext); }
			fp = fopen_dir(buf,mod,1);
	
	} else					/* (searching directory path) */
		for (i=0; !fp && path[i]; i++) for (j=0; j<4 && !fp; j++) {
			strncpy(buf,path[i],bl2-10);
			if (j%2==1 && !dir)  continue;
			if (j%2==1) { strcat(buf,"/");  strcat(buf,dir); }
			l = strlen(buf);
			strcat(buf,"/");  strcat(buf,dfn);
			if (j/2==1 && !ext)  continue;
			if (j/2==(!w) && ext) { strcat(buf,ext); }
			fp = fopen_dir(buf,mod,l+1);
	}
	if (i<0)  fopen_dirused = "";
	else  fopen_dirused = path[i-1];
	FREE(dfn);  FREE(buf);
	return fp;
}

FILE*   fopen_dir(char *fn, char *mod, int pre) {
	FILE    *fp;
	char    *path,*pp;
	extern int	file_overwrite;
	
	if (mod[0]!='w') {		/* normal open for reading */
		fp = fopen(fn,mod);
		return fp;
	}
	if (!file_overwrite) if	((fp = fopen(fn,"r"))!=NULL) {
		if (strncmp(fn,FR_AUTOWRITEPREF,strlen(FR_AUTOWRITEPREF))!=0)
			{USERERROR("Trying to overwrite an existing file \"%s\"!",fn);}
		fclose(fp);
	}
	
	path = MMALLOC(strlen(fn)+5);	/* special open for writing */
	strcpy(path,fn);  pp = path+pre;
	while ((pp = strchr(pp,'/'))!=NULL) {
		*pp = 0;		/* (creates all required subdirectories after pre) */
		mkdir(path,0755);
		*pp++ = '/';
	}
	fp = fopen(path,mod);
	FREE(path);
	return fp; 
}



/**
 * 
 * 
 * extracting the filename (not dir path and not extension)......... - a copy....
 * 
**/

char*	fname_extract(char *fn) {
	char	*x,*y,*z;
	
	for (x=y=z=fn; *x; x++) {
		if (*x=='/')  y = x+1;
		if (*x=='.')  z = x;
	}
	x = MSTRDUP(y);
	if (z>y)  x[(z-y)] = 0;
	return x;
}

char*	fdir_extract(char *fn) {
	char	*x,*y;
	
	x = MSTRDUP(fn);
	for (y=x; *x; x++) {
		if (*x=='/')  y = x;
	}
	y[0] = 0;
	return x;
}








/******************	Pointer arrays	*******************/
/**********************************************************/


/**
 * 
 * allocation of "pointer arrays"... 2D, 3D
 *  these are accessed as pt[][] and pt[][][], and are freed simply with FREE(pt),
 * 
**/

void*	malloc_twodim(int sz, int d1, int d2) {
	void	**pt,*ptd;
	int	i;
	
	pt = MMALLOC((d1+d1%2)*sizeof(void*)+d1*d2*sz);
	ptd = pt+(d1+d1%2);
	for (i=0; i<d1; i++)  pt[i] = (byte1*)ptd+i*sz*d2;
	return pt;
}

void*	malloc_threedim(int sz, int d1, int d2, int d3) {
	void	**pt,**ptm,*ptd;
	int	i,j;
	
	d1 += d1%2;
	pt = MMALLOC((d1+d1*d2)*sizeof(void*)+d1*d2*d3*sz);
	ptm = pt+d1;  ptd = ptm+d1*d2;
	for (i=0; i<d1; i++)  pt[i] = ptm+i*d2;
	for (i=0; i<d1; i++)  for (j=0; j<d2; j++)
		((void***)pt)[i][j] = (byte1*)ptd+(i*d2+j)*sz*d3;
	return pt;
}




































